Index: /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 181)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/SamplingPreprocessor.cpp	(revision 191)
@@ -4,4 +4,6 @@
 #include "X3dExporter.h"
 #include "Environment.h"
+#include "MutualVisibility.h"
+
 SamplingPreprocessor::SamplingPreprocessor()
 {
@@ -33,14 +35,35 @@
 
 int
-SamplingPreprocessor::AddNodeSamples(Intersectable *object, const Ray &ray)
+SamplingPreprocessor::AddNodeSamples(Intersectable *object,
+				     const Ray &ray,
+				     const int pass)
 {
   int contributingSamples = 0;
-
-  for (int j=0; j < ray.leaves.size(); j++) {
+  int j;
+  for (j=0; j < ray.leaves.size(); j++) {
     KdNode *node = GetNodeForPvs( ray.leaves[j] );
     contributingSamples += object->mKdPvs.AddNodeSample(node);
   }
   
+  if (pass > 10)
+    for (j=1; j < ray.leaves.size() - 1; j++) {
+      ray.leaves[j]->AddPassingRay(ray, contributingSamples ? 1 : 0);
+    }
+  
   return contributingSamples;
+}
+
+
+void
+SamplingPreprocessor::HoleSamplingPass()
+{
+  vector<KdLeaf *> leaves;
+  mKdTree->CollectLeaves(leaves);
+  
+  // go through all the leaves and evaluate their passing contribution
+  for (int i=0 ; i < leaves.size(); i++) {
+    KdLeaf *leaf = leaves[i];
+    cout<<leaf->mPassingRays<<endl;
+  }
 }
 
@@ -63,5 +86,4 @@
   int totalSamples = 0;
 
-
   int pvsOut = Min((int)objects.size(), 10);
   
@@ -73,108 +95,118 @@
     int passSampleContributions = 0;
     int passSamples = 0;
-	int index = 0;
-    KdNode *visibleNode = NULL;
+    int index = 0;
 
     for (i =0; i < objects.size(); i++) {
       KdNode *nodeToSample = NULL;
       Intersectable *object = objects[i];
-
+      
       int pvsSize = object->mKdPvs.GetSize();
-
-      
-    if (pvsSize) {
-		// mail all nodes from the pvs
-		Intersectable::NewMail();
-		KdPvsMap::iterator i = object->mKdPvs.mEntries.begin();
-		for (; i != object->mKdPvs.mEntries.end(); i++) {
-			KdNode *node = (*i).first;
-			node->Mail();
-		}
-		int maxTries = 2*pvsSize;
-	
-		for (int tries = 0; tries < 10; tries++) {
-			index = RandomValue(0, pvsSize - 1);
-			KdPvsData data;
-			object->mKdPvs.GetData(index, visibleNode, data);
-			nodeToSample = mKdTree->FindRandomNeighbor(visibleNode, true);
-			if (nodeToSample)
-			break;
-		}
-	}
-
-    if (0 && pvsSize) {
-		// mail all nodes from the pvs
-		Intersectable::NewMail();
-		KdPvsMap::iterator i = object->mKdPvs.mEntries.begin();
-		for (; i != object->mKdPvs.mEntries.end(); i++) {
-			KdNode *node = (*i).first;
-			node->Mail();
-		}
-	
-		vector<KdNode *> invisibleNeighbors;
-		// get all neighbors of all PVS nodes
-		i = object->mKdPvs.mEntries.begin();
-		for (; i != object->mKdPvs.mEntries.end(); i++) {
-			KdNode *node = (*i).first;
-			mKdTree->FindNeighbors(visibleNode, invisibleNeighbors, true);
-		}
-
-		KdPvsData data;
-		KdNode *visibleNode;
-		object->mKdPvs.GetData(index, visibleNode, data);
-		nodeToSample = mKdTree->FindRandomNeighbor(visibleNode, true);
-		if (nodeToSample)
-			break;
-      }
-      
+      
+      if (0 && pvsSize) {
+	// mail all nodes from the pvs
+	Intersectable::NewMail();
+	KdPvsMap::iterator i = object->mKdPvs.mEntries.begin();
+	for (; i != object->mKdPvs.mEntries.end(); i++) {
+	  KdNode *node = (*i).first;
+	  node->Mail();
+	}
+	int maxTries = 2*pvsSize;
+	
+	for (int tries = 0; tries < 10; tries++) {
+	  index = RandomValue(0, pvsSize - 1);
+	  KdPvsData data;
+	  KdNode *node;
+	  object->mKdPvs.GetData(index, node, data);
+	  nodeToSample = mKdTree->FindRandomNeighbor(node, true);
+	  if (nodeToSample)
+	    break;
+	}
+      }
+      
+      if (0 && pvsSize && pass == 100 ) {
+	// mail all nodes from the pvs
+	Intersectable::NewMail();
+	KdPvsMap::iterator i = object->mKdPvs.mEntries.begin();
+	for (; i != object->mKdPvs.mEntries.end(); i++) {
+	  KdNode *node = (*i).first;
+	  node->Mail();
+	}
+	
+	vector<KdNode *> invisibleNeighbors;
+	// get all neighbors of all PVS nodes
+	i = object->mKdPvs.mEntries.begin();
+	for (; i != object->mKdPvs.mEntries.end(); i++) {
+	  KdNode *node = (*i).first;
+	  mKdTree->FindNeighbors(node, invisibleNeighbors, true);
+	  AxisAlignedBox3 box = object->GetBox();
+	  for (int j=0; j < invisibleNeighbors.size(); j++) {
+	    int visibility = ComputeBoxVisibility(mKdTree,
+						  box,
+						  mKdTree->GetBox(invisibleNeighbors[j]),
+						  1.0f);
+	    
+	  }
+	  
+	
+	  // now rank all the neighbors according to probability that a new
+	  // sample creates some contribution
+	}
+      }
 
       for (int k=0; k < mSamplesPerPass; k++) {
-		  object->GetRandomSurfacePoint(point, normal);
-		  if (nodeToSample) {
-			  int maxTries = 5;
-			  for (int tries = 0; tries < maxTries; tries++) {
-				  direction = mKdTree->GetBox(nodeToSample).GetRandomPoint() - point;
-				  if (DotProd(direction, normal) > Limits::Small)
-					break;
-			  }
+	object->GetRandomSurfacePoint(point, normal);
+	if (nodeToSample) {
+	  int maxTries = 5;
+	  for (int tries = 0; tries < maxTries; tries++) {
+	    direction = mKdTree->GetBox(nodeToSample).GetRandomPoint() - point;
+	    if (DotProd(direction, normal) > Limits::Small)
+	      break;
+	  }
 		
-			  if (tries == maxTries)
-				  direction = UniformRandomVector(normal);
-		  } else
-			  direction = UniformRandomVector(normal);
-	
-		  // construct a ray
-		  SetupRay(ray, point, direction);
-		  mKdTree->CastRay(ray);
-
-		  if (i < pvsOut)
-			  rays[i].push_back(ray);
-	
-		  int sampleContributions = 0;
+	  if (tries == maxTries)
+	    direction = UniformRandomVector(normal);
+	} else
+	  direction = UniformRandomVector(normal);
+	
+	// construct a ray
+	SetupRay(ray, point, direction);
+	mKdTree->CastRay(ray);
+
+	if (i < pvsOut)
+	  rays[i].push_back(ray);
+	
+	int sampleContributions = 0;
 	
 		  
-		  if (ray.leaves.size()) {
-			  sampleContributions += AddNodeSamples(object, ray);
+	if (ray.leaves.size()) {
+	  sampleContributions += AddNodeSamples(object, ray, pass);
 	  
-			  if (ray.intersections.size()) {
-				  sampleContributions += AddNodeSamples(ray.intersections[0].mObject, ray);
-				  // check whether we can add this to the rays
-				  for (int j = 0; j < pvsOut; j++) {
-					  if (objects[j] == ray.intersections[0].mObject) {
-						  rays[j].push_back(ray);
-					  }
-				  }
-			  }
+	  if (ray.intersections.size()) {
+	    sampleContributions += AddNodeSamples(ray.intersections[0].mObject, ray, pass);
+	    // check whether we can add this to the rays
+	    for (int j = 0; j < pvsOut; j++) {
+	      if (objects[j] == ray.intersections[0].mObject) {
+		rays[j].push_back(ray);
+	      }
+	    }
+	  }
 		
-			  passSamples++;
+	  passSamples++;
 			
-			  if (sampleContributions) {
-				  passContributingSamples++;
-				  passSampleContributions += sampleContributions;
-			  }
-		  }
-	  }
-	}
+	  if (sampleContributions) {
+	    passContributingSamples++;
+	    passSampleContributions += sampleContributions;
+	  }
+	}
+      }
+    }
+
+
     totalSamples += passSamples;
+
+    //    if (pass>10)
+    //      HoleSamplingPass();
+    
+
     pass++;
     
@@ -193,4 +225,16 @@
       endl;
   }
+
+  int totalPvsSize = mKdTree->CollectLeafPvs();
+  cout<<"#totalPvsSize="<<totalPvsSize<<endl;
+  
+  //  HoleSamplingPass();
+  if (1) {
+    Exporter *exporter = Exporter::GetExporter("ray-density.x3d");
+    exporter->SetExportRayDensity(true);
+    exporter->ExportKdTree(*mKdTree);
+    delete exporter;
+  }
+  
   bool exportRays = false;
   if (exportRays) {
@@ -214,5 +258,5 @@
       KdPvsMap::iterator i = object->mKdPvs.mEntries.begin();
       Intersectable::NewMail();
-	// avoid adding the object to the list
+      // avoid adding the object to the list
       object->Mail();
       ObjectContainer visibleObjects;
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp	(revision 177)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/AxisAlignedBox3.cpp	(revision 191)
@@ -549,5 +549,5 @@
 // x,y,z are either 0 or 1; (0 .. min coordinate, 1 .. max coordinate)
 void
-AxisAlignedBox3::GetVertex(int N, Vector3 &vertex) const
+AxisAlignedBox3::GetVertex(const int N, Vector3 &vertex) const
 {
   switch (N) {
@@ -1526,2 +1526,91 @@
   return (m == M) ? m : m + M;
 }
+
+int
+AxisAlignedBox3::GetFaceVisibilityMask(const Rectangle3 &rectangle) const
+{
+  int mask = 0;
+  for (int i=0; i < 4; i++)
+    mask |= GetFaceVisibilityMask(rectangle.mVertices[i]);
+  return mask;
+}
+
+int
+AxisAlignedBox3::GetFaceVisibilityMask(const Vector3 &position) const {
+  
+  // assume that we are not inside the box
+  int c=0;
+  
+  if (position.x<(mMin.x-Limits::Small))
+    c|=1;
+  else
+    if (position.x>(mMax.x+Limits::Small))
+      c|=2;
+  
+  if (position.y<(mMin.y-Limits::Small))
+    c|=4;
+  else
+    if (position.y>(mMax.y+Limits::Small))
+      c|=8;
+  
+  if (position.z<(mMin.z-Limits::Small))
+    c|=16;
+  else
+    if (position.z>(mMax.z+Limits::Small))
+      c|=32;
+  
+  return c;
+}
+
+
+Rectangle3
+AxisAlignedBox3::GetFace(const int face) const
+{
+  Vector3 v[4];
+  switch (face) {
+    
+  case 0:
+    v[3].SetValue(mMin.x,mMin.y,mMin.z);
+    v[2].SetValue(mMin.x,mMax.y,mMin.z);
+    v[1].SetValue(mMin.x,mMax.y,mMax.z);
+    v[0].SetValue(mMin.x,mMin.y,mMax.z);
+    break;
+    
+  case 1: 
+    v[0].SetValue(mMax.x,mMin.y,mMin.z);
+    v[1].SetValue(mMax.x,mMax.y,mMin.z);
+    v[2].SetValue(mMax.x,mMax.y,mMax.z);
+    v[3].SetValue(mMax.x,mMin.y,mMax.z);
+    break;
+    
+  case 2:
+    v[3].SetValue(mMin.x,mMin.y,mMin.z);
+    v[2].SetValue(mMin.x,mMin.y,mMax.z);
+    v[1].SetValue(mMax.x,mMin.y,mMax.z);
+    v[0].SetValue(mMax.x,mMin.y,mMin.z);
+    break;
+  
+  case 3:
+    v[0].SetValue(mMin.x,mMax.y,mMin.z);
+    v[1].SetValue(mMin.x,mMax.y,mMax.z);
+    v[2].SetValue(mMax.x,mMax.y,mMax.z);
+    v[3].SetValue(mMax.x,mMax.y,mMin.z);
+    break;
+
+  case 4:
+    v[3].SetValue(mMin.x,mMin.y,mMin.z);
+    v[2].SetValue(mMax.x,mMin.y,mMin.z);
+    v[1].SetValue(mMax.x,mMax.y,mMin.z);
+    v[0].SetValue(mMin.x,mMax.y,mMin.z);
+    break;
+  
+  case 5:
+    v[0].SetValue(mMin.x,mMin.y,mMax.z);
+    v[1].SetValue(mMax.x,mMin.y,mMax.z);
+    v[2].SetValue(mMax.x,mMax.y,mMax.z);
+    v[3].SetValue(mMin.x,mMax.y,mMax.z);
+    break;
+  }
+  
+  return Rectangle3(v[0], v[1], v[2], v[3]);
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Camera.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Camera.cpp	(revision 182)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Camera.cpp	(revision 191)
@@ -1,5 +1,9 @@
 #include <algorithm>
-#include <qstring.h>
-#include <qimage.h>
+
+// the devil library
+#include <IL/il.h>
+#include <IL/ilu.h>
+#include <IL/ilut.h>
+
 #include "Camera.h"
 #include "Ray.h"
@@ -7,4 +11,23 @@
 #include "Mesh.h"
 #include "Exporter.h"
+
+
+
+
+void
+InitDevIl()
+{
+  ilInit();
+  ILuint ImageName;
+  ilGenImages(1, &ImageName);
+  ilBindImage(ImageName);
+  ilEnable(IL_FILE_OVERWRITE);
+
+  //  ilRegisterFormat(IL_RGBA);
+  //  ilRegisterType(IL_FLOAT);
+
+  //  ilEnable(IL_ORIGIN_SET);
+  //  ilOriginFunc(IL_ORIGIN_UPPER_LEFT);
+}
 
 bool
@@ -19,9 +42,9 @@
 
   
-#if QT_VERSION < 0x040000
-  QImage image(mWidth, mHeight, 32);
-#else
-  //QImage image(mWidth, mHeight, QImage::Format_RGB32);
-#endif
+  InitDevIl();
+  int components = 4;
+  float *buffer = new float[components*mWidth*mHeight];
+  float *pbuffer = buffer;
+  //  - components*mWidth;
   
   vector<Ray> rays;
@@ -30,8 +53,9 @@
 
   Ray ray;
+
   for (y = 0; y < mHeight; y++) {
     cout<<"+";
     for (x = 0; x < mWidth; x++) {
-      SetupRay(ray, x, y);
+      SetupRay(ray, x, mHeight - (y + 1));
       if (tree->CastRay(ray))
 	if (ray.intersections.size()) {
@@ -41,16 +65,17 @@
 	  if (mesh->GetMesh()->mMaterial)
 	    color = mesh->GetMesh()->mMaterial->mDiffuseColor;
-#if QT_VERSION < 0x040000
-	  image.setPixel(x, y, qRgb(color.r*255,
-				    color.g*255,
-				    color.b*255
-				    ));
-#endif
+
+	  pbuffer[0] = color.r;
+	  pbuffer[1] = color.g;
+	  pbuffer[2] = color.b;
+	  pbuffer[3] = 1.0f;
 
 	}
+      pbuffer+=components;
       
       if (exportRays && (x==222) && (y==97))
 	rays.push_back(ray);
     }
+    //    pbuffer-=2*components*mWidth;
   }
   
@@ -58,9 +83,13 @@
   cout<<"#RAY_CAST_TIME\n";
   cout<<TimeDiff(t1, t2)<<"\n";
+
   
   cout<<"Saving image"<<endl;
-#if QT_VERSION < 0x040000
-  image.save(filename.c_str(), "PNG");
-#endif
+
+  ilRegisterType(IL_FLOAT);
+  ilTexImage(mWidth, mHeight, 1, 4, IL_RGBA, IL_FLOAT, buffer);
+  ilSaveImage((char *const)filename.c_str());
+  delete buffer;
+  
   Exporter *exporter = NULL;
   if (exportRays) {
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Triangle3.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Triangle3.cpp	(revision 191)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Triangle3.cpp	(revision 191)
@@ -0,0 +1,7 @@
+#include "Triangle3.h"
+
+float
+Triangle3::GetSpatialAngle(const Vector3 &point) const
+{
+  return 0.0f;
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Ray.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Ray.cpp	(revision 162)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Ray.cpp	(revision 191)
@@ -121,2 +121,48 @@
 }
 
+void
+PassingRaySet::Reset()
+{
+  for (int i=0; i < 3*Resolution*Resolution; i++)
+    mDirectionalContributions[i] = 0;
+  mRays = 0;
+  mContributions = 0;
+}
+  
+void
+PassingRaySet::AddRay(const Ray &ray, const int contributions)
+{
+  int i = GetEntryIndex(ray.GetDir());
+  mRays++;
+  mContributions += contributions;
+  mDirectionalContributions[i] += contributions;
+}
+
+int
+PassingRaySet::GetEntryIndex(const Vector3 &direction) const
+{
+  // get face
+  int axis = direction.DrivingAxis();
+  Vector3 dir;
+  float k = direction[axis];
+  if ( k < 0.0f)
+    k = -k;
+
+  dir = direction/k;
+  float x, y;
+  dir.ExtractVerts(&x, &y, axis);
+  int ix = (x + 1.0f)*0.5f*Resolution;
+  int iy = (y + 1.0f)*0.5f*Resolution;
+
+  return Resolution*(Resolution*axis + iy) + ix;
+}
+
+ostream &
+operator<<(ostream &s, const PassingRaySet &set)
+{
+  s<<"Ray Set #rays="<<set.mRays<<" #contributions="<<set.mContributions<<endl;
+  for (int i=0; i < 3*sqr(PassingRaySet::Resolution); i++)
+    s<<set.mDirectionalContributions[i]<<" ";
+  s<<endl;
+  return s;
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Mesh.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Mesh.cpp	(revision 176)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Mesh.cpp	(revision 191)
@@ -2,4 +2,5 @@
 #include "Mesh.h"
 #include "MeshKdTree.h"
+#include "Triangle3.h"
 
 int MeshInstance::mailID = 21843194198;
@@ -60,5 +61,5 @@
     switch (ray.GetType()) {
     case Ray::GLOBAL_RAY:
-      ray.intersections.push_back(Ray::RayIntersection(t, instance, faceIndex));
+      ray.intersections.push_back(Ray::Intersection(t, instance, faceIndex));
       hit++;
       break;
@@ -101,7 +102,7 @@
   if ( hits && ray.GetType() == Ray::LOCAL_RAY ) {
     if (ray.intersections.size())
-      ray.intersections[0] = Ray::RayIntersection(nearestT, instance, nearestFace);
+      ray.intersections[0] = Ray::Intersection(nearestT, instance, nearestFace);
     else
-      ray.intersections.push_back(Ray::RayIntersection(nearestT, instance, nearestFace));
+      ray.intersections.push_back(Ray::Intersection(nearestT, instance, nearestFace));
   }
   
@@ -135,7 +136,7 @@
   if ( hits && ray.GetType() == Ray::LOCAL_RAY ) {
     if (ray.intersections.size())
-      ray.intersections[0] = Ray::RayIntersection(nearestT, instance, nearestFace);
+      ray.intersections[0] = Ray::Intersection(nearestT, instance, nearestFace);
     else
-      ray.intersections.push_back(Ray::RayIntersection(nearestT, instance, nearestFace));
+      ray.intersections.push_back(Ray::Intersection(nearestT, instance, nearestFace));
   }
   
@@ -333,2 +334,13 @@
 }
 
+void
+Mesh::AddTriangle(const Triangle3 &triangle)
+{
+  int index = mVertices.size();
+
+  for (int i=0; i < 3; i++) {
+    mVertices.push_back(triangle.mVertices[i]);
+  }
+  
+  AddFace(new Face(index + 0, index + 1, index + 2) );
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h	(revision 176)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/X3dExporter.h	(revision 191)
@@ -57,5 +57,7 @@
   virtual void
   ExportSceneNode(SceneGraphNode *node);
-  
+
+  bool
+  ExportKdTreeRayDensity(const KdTree &tree);
 
   
Index: /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/ilu.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/ilu.h	(revision 191)
+++ /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/ilu.h	(revision 191)
@@ -0,0 +1,190 @@
+//-----------------------------------------------------------------------------
+//
+// ImageLib Utility Sources
+// Copyright (C) 2000-2002 by Denton Woods
+// Last modified: 06/23/2002 <--Y2K Compliant! =]
+//
+// Filename: IL/ilu.h
+//
+// Description: The main include file for ILU
+//
+//-----------------------------------------------------------------------------
+
+
+#ifndef __ilu_h_
+#ifndef __ILU_H__
+
+#define __ilu_h_
+#define __ILU_H__
+
+#include <IL/il.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+/*
+#ifdef _WIN32
+	#if defined(_MSC_VER) || defined(__BORLANDC__)
+		#ifndef IL_STATIC_LIB
+			#pragma comment(lib, "DevIL_DLL.lib")
+			#ifndef _IL_BUILD_LIBRARY
+				#pragma comment(lib, "DevILU_DLL.lib")
+			#endif
+		#else
+			#ifndef _IL_BUILD_LIBRARY
+				#ifdef  IL_DEBUG
+					#pragma comment(lib, "DevILU_DBG.lib")
+				#else
+					#pragma comment(lib, "DevILU.lib")
+				#endif//IL_DEBUG
+			#endif
+		#endif
+	#endif
+#endif
+*/
+
+
+#define ILU_VERSION_1_6_7					1
+#define ILU_VERSION							167
+
+
+#define ILU_FILTER							0x2600
+#define ILU_NEAREST							0x2601
+#define ILU_LINEAR							0x2602
+#define ILU_BILINEAR						0x2603
+#define ILU_SCALE_BOX						0x2604
+#define ILU_SCALE_TRIANGLE					0x2605
+#define ILU_SCALE_BELL						0x2606
+#define ILU_SCALE_BSPLINE					0x2607
+#define ILU_SCALE_LANCZOS3					0x2608
+#define ILU_SCALE_MITCHELL					0x2609
+
+
+// Error types
+#define ILU_INVALID_ENUM					0x0501
+#define ILU_OUT_OF_MEMORY					0x0502
+#define ILU_INTERNAL_ERROR					0x0504
+#define ILU_INVALID_VALUE					0x0505
+#define ILU_ILLEGAL_OPERATION				0x0506
+#define ILU_INVALID_PARAM					0x0509
+
+
+// Values
+#define ILU_PLACEMENT						0x0700
+#define ILU_LOWER_LEFT						0x0701
+#define ILU_LOWER_RIGHT						0x0702
+#define ILU_UPPER_LEFT						0x0703
+#define ILU_UPPER_RIGHT						0x0704
+#define ILU_CENTER							0x0705
+#define ILU_CONVOLUTION_MATRIX				0x0710
+#define ILU_VERSION_NUM						IL_VERSION_NUM
+#define ILU_VENDOR							IL_VENDOR
+
+
+// Filters
+/*
+#define ILU_FILTER_BLUR						0x0803
+#define ILU_FILTER_GAUSSIAN_3x3				0x0804
+#define ILU_FILTER_GAUSSIAN_5X5				0x0805
+#define ILU_FILTER_EMBOSS1					0x0807
+#define ILU_FILTER_EMBOSS2					0x0808
+#define ILU_FILTER_LAPLACIAN1				0x080A
+#define ILU_FILTER_LAPLACIAN2				0x080B
+#define ILU_FILTER_LAPLACIAN3				0x080C
+#define ILU_FILTER_LAPLACIAN4				0x080D
+#define ILU_FILTER_SHARPEN1					0x080E
+#define ILU_FILTER_SHARPEN2					0x080F
+#define ILU_FILTER_SHARPEN3					0x0810
+*/
+
+
+typedef struct ILinfo
+{
+	ILuint	Id;					// the image's id
+	ILubyte	*Data;				// the image's data
+	ILuint	Width;				// the image's width
+	ILuint	Height;				// the image's height
+	ILuint	Depth;				// the image's depth
+	ILubyte	Bpp;				// bytes per pixel (not bits) of the image
+	ILuint	SizeOfData;			// the total size of the data (in bytes)
+	ILenum	Format;				// image format (in IL enum style)
+	ILenum	Type;				// image type (in IL enum style)
+	ILenum	Origin;				// origin of the image
+	ILubyte	*Palette;			// the image's palette
+	ILenum	PalType;			// palette type
+	ILuint	PalSize;			// palette size
+	ILenum	CubeFlags;			// flags for what cube map sides are present
+	ILuint	NumNext;			// number of images following
+	ILuint	NumMips;			// number of mipmaps
+	ILuint	NumLayers;			// number of layers
+} ILinfo;
+
+
+typedef struct ILpointf
+{
+	ILfloat x, y;
+} ILpointf;
+
+typedef struct ILpointi
+{
+	ILint x, y;
+} ILpointi;
+
+
+// ImageLib Utility Functions
+ILAPI ILboolean			ILAPIENTRY iluAlienify(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluBlurAvg(ILuint Iter);
+ILAPI ILboolean			ILAPIENTRY iluBlurGaussian(ILuint Iter);
+ILAPI ILboolean			ILAPIENTRY iluBuildMipmaps(ILvoid);
+ILAPI ILuint			ILAPIENTRY iluColoursUsed(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluCompareImage(ILuint Comp);
+ILAPI ILboolean			ILAPIENTRY iluContrast(ILfloat Contrast);
+ILAPI ILboolean			ILAPIENTRY iluCrop(ILuint XOff, ILuint YOff, ILuint ZOff, ILuint Width, ILuint Height, ILuint Depth);
+ILAPI ILvoid			ILAPIENTRY iluDeleteImage(ILuint Id);
+ILAPI ILboolean			ILAPIENTRY iluEdgeDetectE(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluEdgeDetectP(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluEdgeDetectS(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluEmboss(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluEnlargeCanvas(ILuint Width, ILuint Height, ILuint Depth);
+ILAPI ILboolean			ILAPIENTRY iluEnlargeImage(ILfloat XDim, ILfloat YDim, ILfloat ZDim);
+ILAPI ILboolean			ILAPIENTRY iluEqualize(ILvoid);
+ILAPI const ILstring	ILAPIENTRY iluErrorString(ILenum Error);
+ILAPI ILboolean			ILAPIENTRY iluFlipImage(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluGammaCorrect(ILfloat Gamma);
+ILAPI ILuint			ILAPIENTRY iluGenImage(ILvoid);
+ILAPI ILvoid			ILAPIENTRY iluGetImageInfo(ILinfo *Info);
+ILAPI ILint				ILAPIENTRY iluGetInteger(ILenum Mode);
+ILAPI ILvoid			ILAPIENTRY iluGetIntegerv(ILenum Mode, ILint *Param);
+ILAPI const ILstring	ILAPIENTRY iluGetString(ILenum StringName);
+ILAPI ILvoid			ILAPIENTRY iluImageParameter(ILenum PName, ILenum Param);
+ILAPI ILvoid			ILAPIENTRY iluInit(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluInvertAlpha(ILvoid);
+ILAPI ILuint			ILAPIENTRY iluLoadImage(const ILstring FileName);
+ILAPI ILboolean			ILAPIENTRY iluMirror(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluNegative(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluNoisify(ILclampf Tolerance);
+ILAPI ILboolean			ILAPIENTRY iluPixelize(ILuint PixSize);
+ILAPI ILvoid			ILAPIENTRY iluRegionfv(ILpointf *Points, ILuint n);
+ILAPI ILvoid			ILAPIENTRY iluRegioniv(ILpointi *Points, ILuint n);
+ILAPI ILboolean			ILAPIENTRY iluReplaceColour(ILubyte Red, ILubyte Green, ILubyte Blue, ILfloat Tolerance);
+ILAPI ILboolean			ILAPIENTRY iluRotate(ILfloat Angle);
+ILAPI ILboolean			ILAPIENTRY iluRotate3D(ILfloat x, ILfloat y, ILfloat z, ILfloat Angle);
+ILAPI ILboolean			ILAPIENTRY iluSaturate1f(ILfloat Saturation);
+ILAPI ILboolean			ILAPIENTRY iluSaturate4f(ILfloat r, ILfloat g, ILfloat b, ILfloat Saturation);
+ILAPI ILboolean			ILAPIENTRY iluScale(ILuint Width, ILuint Height, ILuint Depth);
+ILAPI ILboolean			ILAPIENTRY iluScaleColours(ILfloat r, ILfloat g, ILfloat b);
+ILAPI ILboolean			ILAPIENTRY iluSharpen(ILfloat Factor, ILuint Iter);
+ILAPI ILboolean			ILAPIENTRY iluSwapColours(ILvoid);
+ILAPI ILboolean			ILAPIENTRY iluWave(ILfloat Angle);
+
+#define iluColorsUsed	iluColoursUsed
+#define iluSwapColors	iluSwapColours
+#define iluReplaceColor	iluReplaceColour
+#define iluScaleColor	iluScaleColour
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif // __ILU_H__
+#endif // __ilu_h_
Index: /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/config.h.in
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/config.h.in	(revision 191)
+++ /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/config.h.in	(revision 191)
@@ -0,0 +1,62 @@
+/* include/IL/config.h.in.  Generated automatically from configure.in by autoheader.  */
+#ifndef __CONFIG_H__
+#define __CONFIG_H__
+
+
+/* Supported images formats (il) */
+
+#undef IL_NO_BMP
+#undef IL_NO_CUT
+#undef IL_NO_DCX
+#undef IL_NO_DDS
+#undef IL_NO_DOOM
+#undef IL_NO_GIF
+#undef IL_NO_ICO
+#undef IL_NO_JPG
+#undef IL_NO_LCMS
+#undef IL_NO_LIF
+#undef IL_NO_MDL
+#undef IL_NO_MNG
+#undef IL_NO_PCD
+#undef IL_NO_PCX
+#undef IL_NO_PIC
+#undef IL_NO_PIX
+#undef IL_NO_PNG
+#undef IL_NO_PNM
+#undef IL_NO_PSD
+#undef IL_NO_PSP
+#undef IL_NO_PXR
+#undef IL_NO_RAW
+#undef IL_NO_SGI
+#undef IL_NO_TGA
+#undef IL_NO_TIF
+#undef IL_NO_WAL
+#undef IL_NO_XPM
+#undef IL_USE_JPEGLIB_UNMODIFIED
+
+/* Supported api (ilut) */
+
+#undef ILUT_USE_ALLEGRO
+#undef ILUT_USE_DIRECTX8
+#undef ILUT_USE_DIRECTX9
+#undef ILUT_USE_OPENGL
+#undef ILUT_USE_SDL
+#undef ILUT_USE_WIN32
+
+
+/* Define if you have the <dlfcn.h> header file. */
+#undef HAVE_DLFCN_H
+
+/* Name of package */
+#undef PACKAGE
+
+/* Version number of package */
+#undef VERSION
+
+/* Define if your processor stores words with the most significant byte first
+   (like Motorola and SPARC, unlike Intel and VAX). */
+#undef WORDS_BIGENDIAN
+
+/* Define if the X Window System is missing or not being used. */
+#undef X_DISPLAY_MISSING
+#endif /* __CONFIG_H__ */
Index: /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/ilu_region.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/ilu_region.h	(revision 191)
+++ /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/ilu_region.h	(revision 191)
@@ -0,0 +1,27 @@
+//-----------------------------------------------------------------------------
+//
+// ImageLib Utility Sources
+// Copyright (C) 2000-2002 by Denton Woods
+// Last modified: 07/09/2002 <--Y2K Compliant! =]
+//
+// Filename: src-ILU/src/ilu_region.h
+//
+// Description: Creates an image region.
+//
+//-----------------------------------------------------------------------------
+
+#ifndef ILU_REGION_H
+#define ILU_REGION_H
+
+#include "ilu_internal.h"
+
+
+typedef struct Edge
+{
+	ILint	yUpper;
+	ILfloat	xIntersect, dxPerScan;
+	struct	Edge *next;
+} Edge;
+
+
+#endif//ILU_REGION_H
Index: /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/il_wrap.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/il_wrap.h	(revision 191)
+++ /trunk/VUT/GtpVisibilityPreprocessor/support/devil/include/IL/il_wrap.h	(revision 191)
@@ -0,0 +1,205 @@
+#ifndef WRAPPER_H
+#define WRAPPER_H
+
+/*#include <il/il.h>
+#include <il/ilu.h>*/
+#include <il/ilut.h>  // Probably only have to #include this one
+
+#ifdef _MSC_VER
+	#ifndef _IL_WRAP_BUILD_LIB
+		#pragma comment(lib, "il_wrap.lib")
+	#endif
+#endif
+
+class ilImage
+{
+public:
+				ilImage();
+				ilImage(char *);
+				ilImage(const ilImage &);
+	virtual		~ilImage();
+
+	ILboolean	Load(char *);
+	ILboolean	Load(char *, ILenum);
+	ILboolean	Save(char *);
+	ILboolean	Save(char *, ILenum);
+
+
+	// ImageLib functions
+	ILboolean	ActiveImage(ILuint);
+	ILboolean	ActiveLayer(ILuint);
+	ILboolean	ActiveMipmap(ILuint);
+	ILboolean	Clear(ILvoid);
+	ILvoid		ClearColour(ILubyte, ILubyte, ILubyte, ILubyte);
+	ILboolean	Convert(ILenum);
+	ILboolean	Copy(ILuint);
+	ILboolean	Default(ILvoid);
+	ILboolean	Flip(ILvoid);
+	ILboolean	SwapColours(ILvoid);
+	ILboolean	Resize(ILuint, ILuint, ILuint);
+	ILboolean	TexImage(ILuint, ILuint, ILuint, ILubyte, ILenum, ILenum, ILvoid*);
+
+	
+	// Image handling
+	ILvoid		Bind(ILvoid) const;
+	ILvoid		Bind(ILuint);
+	ILvoid		Close(ILvoid) { this->Delete(); }
+	ILvoid		Delete(ILvoid);
+	ILvoid		iGenBind();
+
+
+	// Image characteristics
+	ILuint		Width(ILvoid);
+	ILuint		Height(ILvoid);
+	ILuint		Depth(ILvoid);
+	ILubyte		Bpp(ILvoid);
+	ILubyte		Bitpp(ILvoid);
+	ILenum		PaletteType(ILvoid);
+	ILenum		Format(ILvoid);
+	ILenum		Type(ILvoid);
+	ILuint		NumImages(ILvoid);
+	ILuint		NumMipmaps(ILvoid);
+	ILuint		GetId(ILvoid) const;
+    ILenum      GetOrigin(ILvoid);
+	ILubyte		*GetData(ILvoid);
+	ILubyte		*GetPalette(ILvoid);
+
+
+	// Rendering
+	ILuint		BindImage(ILvoid);
+	ILuint		BindImage(ILenum);
+
+
+	// Operators
+	ilImage&	operator = (ILuint);
+	ilImage&	operator = (const ilImage &);
+
+
+protected:
+	ILuint		Id;
+
+private:
+	ILvoid		iStartUp();
+
+
+};
+
+
+class ilFilters
+{
+public:
+	static ILboolean	Alienify(ilImage &);
+	static ILboolean	BlurAvg(ilImage &, ILuint Iter);
+	static ILboolean	BlurGaussian(ilImage &, ILuint Iter);
+	static ILboolean	Contrast(ilImage &, ILfloat Contrast);
+	static ILboolean	EdgeDetectE(ilImage &);
+	static ILboolean	EdgeDetectP(ilImage &);
+	static ILboolean	EdgeDetectS(ilImage &);
+	static ILboolean	Emboss(ilImage &);
+	static ILboolean	Gamma(ilImage &, ILfloat Gamma);
+	static ILboolean	Negative(ilImage &);
+	static ILboolean	Noisify(ilImage &, ILubyte Factor);
+	static ILboolean	Pixelize(ilImage &, ILuint PixSize);
+	static ILboolean	Saturate(ilImage &, ILfloat Saturation);
+	static ILboolean	Saturate(ilImage &, ILfloat r, ILfloat g, ILfloat b, ILfloat Saturation);
+	static ILboolean	ScaleColours(ilImage &, ILfloat r, ILfloat g, ILfloat b);
+	static ILboolean	Sharpen(ilImage &, ILfloat Factor, ILuint Iter);
+};
+
+
+#ifdef ILUT_USE_OPENGL
+class ilOgl
+{
+public:
+	static ILvoid		Init(ILvoid);
+	static GLuint		BindTex(ilImage &);
+	static ILboolean	Upload(ilImage &, ILuint);
+	static GLuint		Mipmap(ilImage &);
+	static ILboolean	Screen(ILvoid);
+	static ILboolean	Screenie(ILvoid);
+};
+#endif//ILUT_USE_OPENGL
+
+
+#ifdef ILUT_USE_ALLEGRO
+class ilAlleg
+{
+public:
+	static ILvoid	Init(ILvoid);
+	static BITMAP	*Convert(ilImage &);
+};
+#endif//ILUT_USE_ALLEGRO
+
+
+#ifdef ILUT_USE_WIN32
+class ilWin32
+{
+public:
+	static ILvoid		Init(ILvoid);
+	static HBITMAP		Convert(ilImage &);
+	static ILboolean	GetClipboard(ilImage &);
+	static ILvoid		GetInfo(ilImage &, BITMAPINFO *Info);
+	static ILubyte		*GetPadData(ilImage &);
+	static HPALETTE		GetPal(ilImage &);
+	static ILboolean	GetResource(ilImage &, HINSTANCE hInst, ILint ID, char *ResourceType);
+	static ILboolean	GetResource(ilImage &, HINSTANCE hInst, ILint ID, char *ResourceType, ILenum Type);
+	static ILboolean	SetClipboard(ilImage &);
+};
+#endif//ILUT_USE_WIN32
+
+
+class ilValidate
+{
+public:
+	static ILboolean	Valid(ILenum, char *);
+	static ILboolean	Valid(ILenum, FILE *);
+	static ILboolean	Valid(ILenum, ILvoid *, ILuint);
+
+protected:
+
+private:
+
+};
+
+
+class ilState
+{
+public:
+	static ILboolean		Disable(ILenum);
+	static ILboolean		Enable(ILenum);
+	static ILvoid			Get(ILenum, ILboolean &);
+	static ILvoid			Get(ILenum, ILint &);
+	static ILboolean		GetBool(ILenum);
+	static ILint			GetInt(ILenum);
+	static const char		*GetString(ILenum);
+	static ILboolean		IsDisabled(ILenum);
+	static ILboolean		IsEnabled(ILenum);
+	static ILboolean		Origin(ILenum);
+	static ILvoid			Pop(ILvoid);
+	static ILvoid			Push(ILuint);
+
+
+protected:
+
+private:
+
+};
+
+
+class ilError
+{
+public:
+	static ILvoid		Check(ILvoid (*Callback)(const char*));
+	static ILvoid		Check(ILvoid (*Callback)(ILenum));
+	static ILenum		Get(ILvoid);
+	static const char	*String(ILvoid);
+	static const char	*String(ILenum);
+
+protected:
+
+private:
+
+};
+
+
+#endif//WRAPPER_H
